Index: src/molecule.cpp
===================================================================
--- src/molecule.cpp	(revision d09ff7ad9c8d572bf86f780836ed477e92efd995)
+++ src/molecule.cpp	(revision cee0b57afea6660531722346890ed484e9ea8dd4)
@@ -5122,288 +1059,4 @@
 };
 
-bool KeyCompare::operator() (const KeySet SubgraphA, const KeySet SubgraphB) const
-{
-  //cout << "my check is used." << endl;
-  if (SubgraphA.size() < SubgraphB.size()) {
-    return true;
-  } else {
-    if (SubgraphA.size() > SubgraphB.size()) {
-      return false;
-    } else {
-      KeySet::iterator IteratorA = SubgraphA.begin();
-      KeySet::iterator IteratorB = SubgraphB.begin();
-      while ((IteratorA != SubgraphA.end()) && (IteratorB != SubgraphB.end())) {
-        if ((*IteratorA) <  (*IteratorB))
-          return true;
-        else if ((*IteratorA) > (*IteratorB)) {
-            return false;
-          } // else, go on to next index
-        IteratorA++;
-        IteratorB++;
-      } // end of while loop
-    }// end of check in case of equal sizes
-  }
-  return false; // if we reach this point, they are equal
-};
-
-//bool operator < (KeySet SubgraphA, KeySet SubgraphB)
-//{
-//  return KeyCompare(SubgraphA, SubgraphB);
-//};
-
-/** Checking whether KeySet is not already present in Graph, if so just adds factor.
- * \param *out output stream for debugging
- * \param &set KeySet to insert
- * \param &graph Graph to insert into
- * \param *counter pointer to unique fragment count
- * \param factor energy factor for the fragment
- */
-inline void InsertFragmentIntoGraph(ofstream *out, struct UniqueFragments *Fragment)
-{
-  GraphTestPair testGraphInsert;
-
-  testGraphInsert = Fragment->Leaflet->insert(GraphPair (*Fragment->FragmentSet,pair<int,double>(Fragment->FragmentCounter,Fragment->TEFactor)));  // store fragment number and current factor
-  if (testGraphInsert.second) {
-    *out << Verbose(2) << "KeySet " << Fragment->FragmentCounter << " successfully inserted." << endl;
-    Fragment->FragmentCounter++;
-  } else {
-    *out << Verbose(2) << "KeySet " << Fragment->FragmentCounter << " failed to insert, present fragment is " << ((*(testGraphInsert.first)).second).first << endl;
-    ((*(testGraphInsert.first)).second).second += Fragment->TEFactor;  // increase the "created" counter
-    *out << Verbose(2) << "New factor is " << ((*(testGraphInsert.first)).second).second << "." << endl;
-  }
-};
-//void inline InsertIntoGraph(ofstream *out, KeyStack &stack, Graph &graph, int *counter, double factor)
-//{
-//  // copy stack contents to set and call overloaded function again
-//  KeySet set;
-//  for(KeyStack::iterator runner = stack.begin(); runner != stack.begin(); runner++)
-//    set.insert((*runner));
-//  InsertIntoGraph(out, set, graph, counter, factor);
-//};
-
-/** Inserts each KeySet in \a graph2 into \a graph1.
- * \param *out output stream for debugging
- * \param graph1 first (dest) graph
- * \param graph2 second (source) graph
- * \param *counter keyset counter that gets increased
- */
-inline void InsertGraphIntoGraph(ofstream *out, Graph &graph1, Graph &graph2, int *counter)
-{
-  GraphTestPair testGraphInsert;
-
-  for(Graph::iterator runner = graph2.begin(); runner != graph2.end(); runner++) {
-    testGraphInsert = graph1.insert(GraphPair ((*runner).first,pair<int,double>((*counter)++,((*runner).second).second)));  // store fragment number and current factor
-    if (testGraphInsert.second) {
-      *out << Verbose(2) << "KeySet " << (*counter)-1 << " successfully inserted." << endl;
-    } else {
-      *out << Verbose(2) << "KeySet " << (*counter)-1 << " failed to insert, present fragment is " << ((*(testGraphInsert.first)).second).first << endl;
-      ((*(testGraphInsert.first)).second).second += (*runner).second.second;
-      *out << Verbose(2) << "New factor is " << (*(testGraphInsert.first)).second.second << "." << endl;
-    }
-  }
-};
-
-
-/** Performs BOSSANOVA decomposition at selected sites, increasing the cutoff by one at these sites.
- * -# constructs a complete keyset of the molecule
- * -# In a loop over all possible roots from the given rootstack
- *  -# increases order of root site
- *  -# calls PowerSetGenerator with this order, the complete keyset and the rootkeynr
- *  -# for all consecutive lower levels PowerSetGenerator is called with the suborder, the higher order keyset
-as the restricted one and each site in the set as the root)
- *  -# these are merged into a fragment list of keysets
- * -# All fragment lists (for all orders, i.e. from all destination fields) are merged into one list for return
- * Important only is that we create all fragments, it is not important if we create them more than once
- * as these copies are filtered out via use of the hash table (KeySet).
- * \param *out output stream for debugging
- * \param Fragment&*List list of already present keystacks (adaptive scheme) or empty list
- * \param &RootStack stack with all root candidates (unequal to each atom in complete molecule if adaptive scheme is applied)
- * \param *MinimumRingSize minimum ring size for each atom (molecule::Atomcount)
- * \return pointer to Graph list
- */
-void molecule::FragmentBOSSANOVA(ofstream *out, Graph *&FragmentList, KeyStack &RootStack, int *MinimumRingSize)
-{
-  Graph ***FragmentLowerOrdersList = NULL;
-  int NumLevels, NumMolecules, TotalNumMolecules = 0, *NumMoleculesOfOrder = NULL;
-  int counter = 0, Order;
-  int UpgradeCount = RootStack.size();
-  KeyStack FragmentRootStack;
-  int RootKeyNr, RootNr;
-  struct UniqueFragments FragmentSearch;
-
-  *out << Verbose(0) << "Begin of FragmentBOSSANOVA." << endl;
-
-  // FragmentLowerOrdersList is a 2D-array of pointer to MoleculeListClass objects, one dimension represents the ANOVA expansion of a single order (i.e. 5)
-  // with all needed lower orders that are subtracted, the other dimension is the BondOrder (i.e. from 1 to 5)
-  NumMoleculesOfOrder = Malloc<int>(UpgradeCount, "molecule::FragmentBOSSANOVA: *NumMoleculesOfOrder");
-  FragmentLowerOrdersList = Malloc<Graph**>(UpgradeCount, "molecule::FragmentBOSSANOVA: ***FragmentLowerOrdersList");
-
-  // initialise the fragments structure
-  FragmentSearch.ShortestPathList = Malloc<int>(AtomCount, "molecule::PowerSetGenerator: *ShortestPathList");
-  FragmentSearch.FragmentCounter = 0;
-  FragmentSearch.FragmentSet = new KeySet;
-  FragmentSearch.Root = FindAtom(RootKeyNr);
-  for (int i=AtomCount;i--;) {
-    FragmentSearch.ShortestPathList[i] = -1;
-  }
-
-  // Construct the complete KeySet which we need for topmost level only (but for all Roots)
-  atom *Walker = start;
-  KeySet CompleteMolecule;
-  while (Walker->next != end) {
-    Walker = Walker->next;
-    CompleteMolecule.insert(Walker->GetTrueFather()->nr);
-  }
-
-  // this can easily be seen: if Order is 5, then the number of levels for each lower order is the total sum of the number of levels above, as
-  // each has to be split up. E.g. for the second level we have one from 5th, one from 4th, two from 3th (which in turn is one from 5th, one from 4th),
-  // hence we have overall four 2th order levels for splitting. This also allows for putting all into a single array (FragmentLowerOrdersList[])
-  // with the order along the cells as this: 5433222211111111 for BondOrder 5 needing 16=pow(2,5-1) cells (only we use bit-shifting which is faster)
-  RootNr = 0;   // counts through the roots in RootStack
-  while ((RootNr < UpgradeCount) && (!RootStack.empty())) {
-    RootKeyNr = RootStack.front();
-    RootStack.pop_front();
-    Walker = FindAtom(RootKeyNr);
-    // check cyclic lengths
-    //if ((MinimumRingSize[Walker->GetTrueFather()->nr] != -1) && (Walker->GetTrueFather()->AdaptiveOrder+1 > MinimumRingSize[Walker->GetTrueFather()->nr])) {
-    //  *out << Verbose(0) << "Bond order " << Walker->GetTrueFather()->AdaptiveOrder << " of Root " << *Walker << " greater than or equal to Minimum Ring size of " << MinimumRingSize << " found is not allowed." << endl;
-    //} else
-    {
-      // increase adaptive order by one
-      Walker->GetTrueFather()->AdaptiveOrder++;
-      Order = Walker->AdaptiveOrder = Walker->GetTrueFather()->AdaptiveOrder;
-
-      // initialise Order-dependent entries of UniqueFragments structure
-      FragmentSearch.BondsPerSPList = Malloc<bond*>(Order * 2, "molecule::PowerSetGenerator: ***BondsPerSPList");
-      FragmentSearch.BondsPerSPCount = Malloc<int>(Order, "molecule::PowerSetGenerator: *BondsPerSPCount");
-      for (int i=Order;i--;) {
-        FragmentSearch.BondsPerSPList[2*i] = new bond();    // start node
-        FragmentSearch.BondsPerSPList[2*i+1] = new bond();  // end node
-        FragmentSearch.BondsPerSPList[2*i]->next = FragmentSearch.BondsPerSPList[2*i+1];     // intertwine these two
-        FragmentSearch.BondsPerSPList[2*i+1]->previous = FragmentSearch.BondsPerSPList[2*i];
-        FragmentSearch.BondsPerSPCount[i] = 0;
-      }
-
-      // allocate memory for all lower level orders in this 1D-array of ptrs
-      NumLevels = 1 << (Order-1); // (int)pow(2,Order);
-      FragmentLowerOrdersList[RootNr] = Malloc<Graph*>(NumLevels, "molecule::FragmentBOSSANOVA: **FragmentLowerOrdersList[]");
-      for (int i=0;i<NumLevels;i++)
-        FragmentLowerOrdersList[RootNr][i] = NULL;
-
-      // create top order where nothing is reduced
-      *out << Verbose(0) << "==============================================================================================================" << endl;
-      *out << Verbose(0) << "Creating KeySets of Bond Order " << Order << " for " << *Walker << ", " << (RootStack.size()-RootNr) << " Roots remaining." << endl; // , NumLevels is " << NumLevels << "
-
-      // Create list of Graphs of current Bond Order (i.e. F_{ij})
-      FragmentLowerOrdersList[RootNr][0] =  new Graph;
-      FragmentSearch.TEFactor = 1.;
-      FragmentSearch.Leaflet = FragmentLowerOrdersList[RootNr][0];      // set to insertion graph
-      FragmentSearch.Root = Walker;
-      NumMoleculesOfOrder[RootNr] = PowerSetGenerator(out, Walker->AdaptiveOrder, FragmentSearch, CompleteMolecule);
-      *out << Verbose(1) << "Number of resulting KeySets is: " << NumMoleculesOfOrder[RootNr] << "." << endl;
-      if (NumMoleculesOfOrder[RootNr] != 0) {
-        NumMolecules = 0;
-
-        // we don't have to dive into suborders! These keysets are all already created on lower orders!
-        // this was all ancient stuff, when we still depended on the TEFactors (and for those the suborders were needed)
-
-//        if ((NumLevels >> 1) > 0) {
-//          // create lower order fragments
-//          *out << Verbose(0) << "Creating list of unique fragments of lower Bond Order terms to be subtracted." << endl;
-//          Order = Walker->AdaptiveOrder;
-//          for (int source=0;source<(NumLevels >> 1);source++) { // 1-terms don't need any more splitting, that's why only half is gone through (shift again)
-//            // step down to next order at (virtual) boundary of powers of 2 in array
-//            while (source >= (1 << (Walker->AdaptiveOrder-Order))) // (int)pow(2,Walker->AdaptiveOrder-Order))
-//              Order--;
-//            *out << Verbose(0) << "Current Order is: " << Order << "." << endl;
-//            for (int SubOrder=Order-1;SubOrder>0;SubOrder--) {
-//              int dest = source + (1 << (Walker->AdaptiveOrder-(SubOrder+1)));
-//              *out << Verbose(0) << "--------------------------------------------------------------------------------------------------------------" << endl;
-//              *out << Verbose(0) << "Current SubOrder is: " << SubOrder << " with source " << source << " to destination " << dest << "." << endl;
-//
-//              // every molecule is split into a list of again (Order - 1) molecules, while counting all molecules
-//              //*out << Verbose(1) << "Splitting the " << (*FragmentLowerOrdersList[RootNr][source]).size() << " molecules of the " << source << "th cell in the array." << endl;
-//              //NumMolecules = 0;
-//              FragmentLowerOrdersList[RootNr][dest] = new Graph;
-//              for(Graph::iterator runner = (*FragmentLowerOrdersList[RootNr][source]).begin();runner != (*FragmentLowerOrdersList[RootNr][source]).end(); runner++) {
-//                for (KeySet::iterator sprinter = (*runner).first.begin();sprinter != (*runner).first.end(); sprinter++) {
-//                  Graph TempFragmentList;
-//                  FragmentSearch.TEFactor = -(*runner).second.second;
-//                  FragmentSearch.Leaflet = &TempFragmentList;      // set to insertion graph
-//                  FragmentSearch.Root = FindAtom(*sprinter);
-//                  NumMoleculesOfOrder[RootNr] += PowerSetGenerator(out, SubOrder, FragmentSearch, (*runner).first);
-//                  // insert new keysets FragmentList into FragmentLowerOrdersList[Walker->AdaptiveOrder-1][dest]
-//                  *out << Verbose(1) << "Merging resulting key sets with those present in destination " << dest << "." << endl;
-//                  InsertGraphIntoGraph(out, *FragmentLowerOrdersList[RootNr][dest], TempFragmentList, &NumMolecules);
-//                }
-//              }
-//              *out << Verbose(1) << "Number of resulting molecules for SubOrder " << SubOrder << " is: " << NumMolecules << "." << endl;
-//            }
-//          }
-//        }
-      } else {
-        Walker->GetTrueFather()->MaxOrder = true;
-//        *out << Verbose(1) << "Hence, we don't dive into SubOrders ... " << endl;
-      }
-      // now, we have completely filled each cell of FragmentLowerOrdersList[] for the current Walker->AdaptiveOrder
-      //NumMoleculesOfOrder[Walker->AdaptiveOrder-1] = NumMolecules;
-      TotalNumMolecules += NumMoleculesOfOrder[RootNr];
-//      *out << Verbose(1) << "Number of resulting molecules for Order " << (int)Walker->GetTrueFather()->AdaptiveOrder << " is: " << NumMoleculesOfOrder[RootNr] << "." << endl;
-      RootStack.push_back(RootKeyNr); // put back on stack
-      RootNr++;
-
-      // free Order-dependent entries of UniqueFragments structure for next loop cycle
-      Free(&FragmentSearch.BondsPerSPCount);
-      for (int i=Order;i--;) {
-        delete(FragmentSearch.BondsPerSPList[2*i]);
-        delete(FragmentSearch.BondsPerSPList[2*i+1]);
-      }
-      Free(&FragmentSearch.BondsPerSPList);
-    }
-  }
-  *out << Verbose(0) << "==============================================================================================================" << endl;
-  *out << Verbose(1) << "Total number of resulting molecules is: " << TotalNumMolecules << "." << endl;
-  *out << Verbose(0) << "==============================================================================================================" << endl;
-
-  // cleanup FragmentSearch structure
-  Free(&FragmentSearch.ShortestPathList);
-  delete(FragmentSearch.FragmentSet);
-
-  // now, FragmentLowerOrdersList is complete, it looks - for BondOrder 5 - as this (number is the ANOVA Order of the terms therein)
-  // 5433222211111111
-  // 43221111
-  // 3211
-  // 21
-  // 1
-
-  // Subsequently, we combine all into a single list (FragmentList)
-
-  *out << Verbose(0) << "Combining the lists of all orders per order and finally into a single one." << endl;
-  if (FragmentList == NULL) {
-    FragmentList = new Graph;
-    counter = 0;
-  } else {
-    counter = FragmentList->size();
-  }
-  RootNr = 0;
-  while (!RootStack.empty()) {
-    RootKeyNr = RootStack.front();
-    RootStack.pop_front();
-    Walker = FindAtom(RootKeyNr);
-    NumLevels = 1 << (Walker->AdaptiveOrder - 1);
-    for(int i=0;i<NumLevels;i++) {
-      if (FragmentLowerOrdersList[RootNr][i] != NULL) {
-        InsertGraphIntoGraph(out, *FragmentList, (*FragmentLowerOrdersList[RootNr][i]), &counter);
-        delete(FragmentLowerOrdersList[RootNr][i]);
-      }
-    }
-    Free(&FragmentLowerOrdersList[RootNr]);
-    RootNr++;
-  }
-  Free(&FragmentLowerOrdersList);
-  Free(&NumMoleculesOfOrder);
-
-  *out << Verbose(0) << "End of FragmentBOSSANOVA." << endl;
-};
 
 /** Comparison function for GSL heapsort on distances in two molecules.
Index: src/molecule.hpp
===================================================================
--- src/molecule.hpp	(revision d09ff7ad9c8d572bf86f780836ed477e92efd995)
+++ src/molecule.hpp	(revision cee0b57afea6660531722346890ed484e9ea8dd4)
@@ -1,3 +1,3 @@
-/** \file molecules.hpp
+/** \file molecule.hpp
  *
  * Class definitions of atom and molecule, element and periodentafel
@@ -133,7 +133,15 @@
 
   // templates for allowing global manipulation of all vectors
+  template <typename res> void ActOnAllVectors( res (Vector::*f)() );
   template <typename res, typename T> void ActOnAllVectors( res (Vector::*f)(T), T t );
   template <typename res, typename T, typename U> void ActOnAllVectors( res (Vector::*f)(T, U), T t, U u );
   template <typename res, typename T, typename U, typename V> void ActOnAllVectors( res (Vector::*f)(T, U, V), T t, U u, V v);
+
+  // templates for allowing global manipulation of all atoms
+  template <typename res> void ActOnAllAtoms( res (molecule::*f)(atom *) );
+  template <typename res> void ActOnAllAtoms( res (atom::*f)() );
+  template <typename res, typename T> void ActOnAllAtoms( res (atom::*f)(T), T t );
+  template <typename res, typename T, typename U> void ActOnAllAtoms( res (atom::*f)(T, U), T t, U u );
+  template <typename res, typename T, typename U, typename V> void ActOnAllAtoms( res (atom::*f)(T, U, V), T t, U u, V v);
 
   /// remove atoms from molecule.
@@ -147,5 +155,5 @@
   bool AddXYZFile(string filename);
   bool AddHydrogenReplacementAtom(ofstream *out, bond *Bond, atom *BottomOrigin, atom *TopOrigin, atom *TopReplacement, bond **BondList, int NumBond, bool IsAngstroem);
-  bond * AddBond(atom *first, atom *second, int degree);
+  bond * AddBond(atom *first, atom *second, int degree = 1);
   bool RemoveBond(bond *pointer);
   bool RemoveBonds(atom *BondPartner);
@@ -255,4 +263,11 @@
 
 
+template <typename res> void molecule::ActOnAllVectors( res (Vector::*f)() ) {
+  atom *Walker = start;
+  while (Walker->next != end) {
+    Walker = Walker->next;
+    ((Walker->node)->*f)();
+  }
+};
 template <typename res, typename T> void molecule::ActOnAllVectors( res (Vector::*f)(T), T t )
 {
@@ -260,8 +275,7 @@
   while (Walker->next != end) {
     Walker = Walker->next;
-    ((*Walker->node)->*f)(t);
-  }
-};
-
+    ((Walker->node)->*f)(t);
+  }
+};
 template <typename res, typename T, typename U> void molecule::ActOnAllVectors( res (Vector::*f)(T, U), T t, U u )
 {
@@ -269,8 +283,7 @@
   while (Walker->next != end) {
     Walker = Walker->next;
-    ((*Walker->node)->*f)(t, u);
-  }
-};
-
+    ((Walker->node)->*f)(t, u);
+  }
+};
 template <typename res, typename T, typename U, typename V> void molecule::ActOnAllVectors( res (Vector::*f)(T, U, V), T t, U u, V v)
 {
@@ -278,5 +291,45 @@
   while (Walker->next != end) {
     Walker = Walker->next;
-    ((*Walker->node)->*f)(t, u, v);
+    ((Walker->node)->*f)(t, u, v);
+  }
+};
+
+template <typename res> void molecule::ActOnAllAtoms( res (molecule::*f)(atom *)) {
+  atom *Walker = start;
+  while (Walker->next != end) {
+    Walker = Walker->next;
+    (*f)(Walker);
+  }
+};
+
+template <typename res> void molecule::ActOnAllAtoms( res (atom::*f)()) {
+  atom *Walker = start;
+  while (Walker->next != end) {
+    Walker = Walker->next;
+    (Walker->*f)();
+  }
+};
+template <typename res, typename T> void molecule::ActOnAllAtoms( res (atom::*f)(T), T t )
+{
+  atom *Walker = start;
+  while (Walker->next != end) {
+    Walker = Walker->next;
+    (Walker->*f)(t);
+  }
+};
+template <typename res, typename T, typename U> void molecule::ActOnAllAtoms( res (atom::*f)(T, U), T t, U u )
+{
+  atom *Walker = start;
+  while (Walker->next != end) {
+    Walker = Walker->next;
+    (Walker->*f)(t, u);
+  }
+};
+template <typename res, typename T, typename U, typename V> void molecule::ActOnAllAtoms( res (atom::*f)(T, U, V), T t, U u, V v)
+{
+  atom *Walker = start;
+  while (Walker->next != end) {
+    Walker = Walker->next;
+    (Walker->*f)(t, u, v);
   }
 };
